lorom ; This patch formatted for use with xkas v0.06

; Values used to increase collectible totals with each type of pickup
!EnergyInc = #$0064 : !ReserveInc = #$0064
!MissileInc = #$0005 : !SMissileInc = #$0005 : !PBombInc = #$0005

org $84E099
namespace "CREItem"
Normal:
DW #$887C,#$DFA9,#$8724, Start

Ball:
DW #$887C,#$DFA9,#$8A2E,#$DFAF,#$8A2E,#$DFC7

Start:
DW #$8A24, Goto, #$86C1,#$DF89,#$874E : DB #$16

namespace off
DW LoadItemTable, GfxTable ; Referencing a label, must be outside of the namespace
namespace "CREItem"

Goto:
DW #$8A24,#$DFA9,#$8724, GetItem

Respawn:
DW #$8A2E,#$E032

Block:
DW #$8A2E,#$E007,#$887C, Respawn, #$8A24, BlockGoto, #$86C1,#$DF89,#$874E : DB #$16

namespace off
DW LoadItemTable, TimerTable
namespace "CREItem"

BlockGoto:
DW #$8A24, Respawn

GetItem:
DW #$8899,#$8BDD : DB #$02
namespace off
DW LoadItemTable, ItemTable


VRAMItem_Setup:
DW LoadItemTable, GfxTable
namespace "VRAMItem"
Normal:
DW #$887C,#$DFA9,#$8A2E, Setup, #$8724, Start

Ball:
DW #$887C,#$DFA9,#$8A2E, Setup, #$8A2E,#$DFAF,#$8A2E,#$DFC7

Start:
DW #$8A24, Goto, #$86C1,#$DF89,#$874E : DB #$16

.Gfx
DW #$E04F,#$E067,#$8724, .Gfx

Goto:
DW #$8A24,#$DFA9,#$8724, GetItem

Block:
DW #$8A2E, Setup, #$8724, BlockLoop

Respawn:
DW #$8A2E,#$E032

BlockLoop:
DW #$8A2E,#$E007,#$887C, Respawn, #$8A24, BlockGoto, #$86C1,#$DF89,#$874E : DB #$16

.Gfx
DW #$E04F,#$E067,#$873F, .Gfx, #$8A2E,#$E020,#$8724, BlockLoop

BlockGoto:
DW #$8A24, Respawn

GetItem:
DW #$8899,#$8BDD : DB #$02
namespace off
DW LoadItemTable, ItemTable

; Custom PLM Instruction: go to Instruction loaded from a table (Y) indexed by the Item number
LoadItemTable:
LDA $0000,Y
STA $12
LDA $7E1C37,X
-
CMP #BallPLMs : BCC +
SBC #$0054
BRA -
+
SEC : SBC #ItemPLMs
LSR A
TAY
LDA ($12),Y
TAY
RTS

; Used by Speed Booster (called upon pickup of the Item), can be used for other Items
LavaRise:
LDA #$FFE0 : STA $197C : RTS

; Item acquisition table, add entries past ReserveTank to add items
ItemTable:
DW EnergyTank_Acquired, MissileTank_Acquired, SuperTank_Acquired, PBombTank_Acquired
DW Bomb_Acquired, Charge_Acquired, Ice_Acquired, HiJump_Acquired, SpeedBooster_Acquired
DW Wave_Acquired, Spazer_Acquired, SpringBall_Acquired, Varia_Acquired, Gravity_Acquired
DW XRay_Acquired, Plasma_Acquired, Grapple_Acquired, SpaceJump_Acquired, ScrewAttack_Acquired
DW MorphBall_Acquired, ReserveTank_Acquired

; Item Graphics table, add entries past ReserveTank to add items (keep items in same order as acquisition table)
GfxTable:
DW EnergyTank_Gfx, MissileTank_Gfx, SuperTank_Gfx, PBombTank_Gfx
DW Bomb_Gfx, Charge_Gfx, Ice_Gfx, HiJump_Gfx, SpeedBooster_Gfx
DW Wave_Gfx, Spazer_Gfx, SpringBall_Gfx, Varia_Gfx, Gravity_Gfx
DW XRay_Gfx, Plasma_Gfx, Grapple_Gfx, SpaceJump_Gfx, ScrewAttack_Gfx
DW MorphBall_Gfx, ReserveTank_Gfx

; Timer-based Graphics, only used by CRE Items (CRE Items MUST come before VRAM Items)
TimerTable:
DW EnergyTank_TimerGfx, MissileTank_TimerGfx, SuperTank_TimerGfx, PBombTank_TimerGfx

; The entries below define the unique PLM data for each item - the generic items will jump to these instruction lists
namespace "EnergyTank"
Acquired:
DW #$8968, !EnergyInc, #$8A3A
Gfx:
DW #$0004,#$A2DF,#$0004,#$A2E5,#$8724, Gfx
TimerGfx:
DW #$0004,#$A2DF,#$0004,#$A2E5,#$873F, TimerGfx, #$8A2E,#$E020
namespace off
DW #$8724, CREItem_Block

namespace "MissileTank"
Acquired:
DW #$89A9, !MissileInc, #$8A3A
Gfx:
DW #$0004,#$A2EB,#$0004,#$A2F1,#$8724, Gfx
TimerGfx:
DW #$0004,#$A2EB,#$0004,#$A2F1,#$873F, TimerGfx, #$8A2E,#$E020
namespace off
DW #$8724, CREItem_Block

namespace "SuperTank"
Acquired:
DW #$89D2, !SMissileInc, #$8A3A
Gfx:
DW #$0004,#$A2F7,#$0004,#$A2FD,#$8724, Gfx
TimerGfx:
DW #$0004,#$A2F7,#$0004,#$A2FD,#$873F, TimerGfx, #$8A2E,#$E020
namespace off
DW #$8724, CREItem_Block

namespace "PBombTank"
Acquired:
DW #$89FB, !PBombInc, #$8A3A
Gfx:
DW #$0004,#$A303,#$0004,#$A309,#$8724, Gfx
TimerGfx:
DW #$0004,#$A303,#$0004,#$A309,#$873F, TimerGfx, #$8A2E,#$E020
namespace off
DW #$8724, CREItem_Block

namespace "Bomb"
Acquired:
DW #$88F3,#$1000 : DB #$13 : DW #$8A3A
Gfx:
DW #$8764,#$8000 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "Charge"
Acquired:
DW #$88B0,#$1000 : DB #$0E : DW #$8A3A
Gfx:
DW #$8764,#$8B00 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "Ice"
Acquired:
DW #$88B0,#$0002 : DB #$0F : DW #$8A3A
Gfx:
DW #$8764,#$8C00 : DB #$00,#$03,#$00,#$00,#$00,#$03,#$00,#$00 : DW #$8A3A
namespace off

namespace "HiJump"
Acquired:
DW #$88F3,#$0100 : DB #$0B : DW #$8A3A
Gfx:
DW #$8764,#$8400 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "SpeedBooster"
Acquired:
DW #$88F3,#$2000 : DB #$0D
namespace off
DW LavaRise, #$8A3A ; Triggers the rising lava - references a label, so it must be outside of a namespace
namespace "SpeedBooster"
Gfx:
DW #$8764,#$8A00 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "Wave"
Acquired:
DW #$88B0,#$0001 : DB #$10 : DW #$8A3A
Gfx:
DW #$8764,#$8D00 : DB #$00,#$02,#$00,#$00,#$00,#$02,#$00,#$00 : DW #$8A3A
namespace off

namespace "Spazer"
Acquired:
DW #$88B0,#$0004 : DB #$11 : DW #$8A3A
Gfx:
DW #$8764,#$8F00 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "SpringBall"
Acquired:
DW #$88F3,#$0002 : DB #$08 : DW #$8A3A
Gfx:
DW #$8764,#$8200 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

ZeroCharge: ; Used by both Suit items
STZ $0CD0 : RTS

Varia_Acquired:
DW ZeroCharge, #$88F3,#$0001 : DB #$07
DW #$870B : DL #$91D4E4 : DW #$8A3A ; $91D4E4 calls the Varia Suit effect
namespace "Varia"
Gfx:
DW #$8764,#$8300 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

Gravity_Acquired:
DW ZeroCharge, #$88F3,#$0020 : DB #$1A
DW #$870B : DL #$91D5BA : DW #$8A3A ; $91D5BA calls the Gravity Suit effect
namespace "Gravity"
Gfx:
DW #$8764,#$8100 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "XRay"
Acquired:
DW #$8941,#$8000 : DW #$8A3A
Gfx:
DW #$8764,#$8900 : DB #$01,#$01,#$00,#$00,#$03,#$03,#$00,#$00 : DW #$8A3A
namespace off

namespace "Plasma"
Acquired:
DW #$88B0,#$0008 : DB #$12 : DW #$8A3A
Gfx:
DW #$8764,#$8E00 : DB #$00,#$01,#$00,#$00,#$00,#$01,#$00,#$00 : DW #$8A3A
namespace off

namespace "Grapple"
Acquired:
DW #$891A,#$4000 : DW #$8A3A
Gfx:
DW #$8764,#$8800 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "SpaceJump"
Acquired:
DW #$88F3,#$0200 : DB #$0C : DW #$8A3A
Gfx:
DW #$8764,#$8600 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "ScrewAttack"
Acquired:
DW #$88F3,#$0008 : DB #$0A : DW #$8A3A
Gfx:
DW #$8764,#$8500 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "MorphBall"
Acquired:
DW #$88F3,#$0004 : DB #$09 : DW #$8A3A
Gfx:
DW #$8764,#$8700 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

namespace "ReserveTank"
Acquired:
DW #$8986, !ReserveInc, #$8A3A
Gfx:
DW #$8764,#$9000 : DB #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00 : DW #$8A3A
namespace off

padbyte $FF : pad $84EE4D ; Fill the remainder of space with FF's, can be omitted if needed

{ ; PLM Headers
	org $84EED7
ItemPLMs:
	DW #$EE4D, CREItem_Normal ; Energy Tank
	DW #$EE52, CREItem_Normal ; Missile Tank
	DW #$EE57, CREItem_Normal ; Super Missile Tank
	DW #$EE5C, CREItem_Normal ; Power Bomb Tank
	DW #$EE64, VRAMItem_Normal ; Bomb
	DW #$EE64, VRAMItem_Normal ; Charge Beam
	DW #$EE64, VRAMItem_Normal ; Ice Beam
	DW #$EE64, VRAMItem_Normal ; Hi-Jump Boots
	DW #$EE64, VRAMItem_Normal ; Speed Booster
	DW #$EE64, VRAMItem_Normal ; Wave Beam
	DW #$EE64, VRAMItem_Normal ; Spazer
	DW #$EE64, VRAMItem_Normal ; Spring Ball
	DW #$EE64, VRAMItem_Normal ; Varia Suit
	DW #$EE64, VRAMItem_Normal ; Gravity Suit
	DW #$EE64, VRAMItem_Normal ; X-Ray Scope
	DW #$EE64, VRAMItem_Normal ; Plasma Beam
	DW #$EE64, VRAMItem_Normal ; Grapple Beam
	DW #$EE64, VRAMItem_Normal ; Space Jump
	DW #$EE64, VRAMItem_Normal ; Screw Attack
	DW #$EE64, VRAMItem_Normal ; Morph Ball
	DW #$EE64, VRAMItem_Normal ; Reserve Tank

BallPLMs: ; $84EF2B
	DW #$EE4D, CREItem_Ball ; Energy Tank
	DW #$EE52, CREItem_Ball ; Missile Tank
	DW #$EE57, CREItem_Ball ; Super Missile Tank
	DW #$EE5C, CREItem_Ball ; Power Bomb Tank
	DW #$EE64, VRAMItem_Ball ; Bomb
	DW #$EE64, VRAMItem_Ball ; Charge Beam
	DW #$EE64, VRAMItem_Ball ; Ice Beam
	DW #$EE64, VRAMItem_Ball ; Hi-Jump Boots
	DW #$EE64, VRAMItem_Ball ; Speed Booster
	DW #$EE64, VRAMItem_Ball ; Wave Beam
	DW #$EE64, VRAMItem_Ball ; Spazer
	DW #$EE64, VRAMItem_Ball ; Spring Ball
	DW #$EE64, VRAMItem_Ball ; Varia Suit
	DW #$EE64, VRAMItem_Ball ; Gravity Suit
	DW #$EE64, VRAMItem_Ball ; X-Ray Scope
	DW #$EE64, VRAMItem_Ball ; Plasma Beam
	DW #$EE64, VRAMItem_Ball ; Grapple Beam
	DW #$EE64, VRAMItem_Ball ; Space Jump
	DW #$EE64, VRAMItem_Ball ; Screw Attack
	DW #$EE64, VRAMItem_Ball ; Morph Ball
	DW #$EE64, VRAMItem_Ball ; Reserve Tank

BlockPLMs: ; $84EF7F
	DW #$EE77, CREItem_Block ; Energy Tank
	DW #$EE7C, CREItem_Block ; Missile Tank
	DW #$EE81, CREItem_Block ; Super Missile Tank
	DW #$EE86, CREItem_Block ; Power Bomb Tank
	DW #$EE8E, VRAMItem_Block ; Bomb
	DW #$EE8E, VRAMItem_Block ; Charge Beam
	DW #$EE8E, VRAMItem_Block ; Ice Beam
	DW #$EE8E, VRAMItem_Block ; Hi-Jump Boots
	DW #$EE8E, VRAMItem_Block ; Speed Booster
	DW #$EE8E, VRAMItem_Block ; Wave Beam
	DW #$EE8E, VRAMItem_Block ; Spazer
	DW #$EE8E, VRAMItem_Block ; Spring Ball
	DW #$EE8E, VRAMItem_Block ; Varia Suit
	DW #$EE8E, VRAMItem_Block ; Gravity Suit
	DW #$EE8E, VRAMItem_Block ; X-Ray Scope
	DW #$EE8E, VRAMItem_Block ; Plasma Beam
	DW #$EE8E, VRAMItem_Block ; Grapple Beam
	DW #$EE8E, VRAMItem_Block ; Space Jump
	DW #$EE8E, VRAMItem_Block ; Screw Attack
	DW #$EE8E, VRAMItem_Block ; Morph Ball
	DW #$EE8E, VRAMItem_Block ; Reserve Tank
}
